
#include "RMeshPolyhedralDomain.h"

RMeshPolyhedralDomain::RMeshPolyhedralDomain()
{
    // empty for now
}

void RMeshPolyhedralDomain::CreateMesh()
{
     // Create polyhedron
  Polyhedron polyhedron;
  std::ifstream input("_unionPoly.off");
  input >> polyhedron;

  // Create domain
  Mesh_domain domain(polyhedron);

  // Set mesh criteria
  Facet_criteria facet_criteria(25, 0.15, 0.008); // angle, size, approximation
  Cell_criteria cell_criteria(4, 0.2); // radius-edge ratio, size
  Mesh_criteria criteria(facet_criteria, cell_criteria);

  // Mesh generation
  C3t3 c3t3 = CGAL::make_mesh_3<C3t3>(domain, criteria);

  // Output
  std::ofstream medit_file("out.mesh");
  c3t3.output_to_medit(medit_file);
  medit_file.close();
}

