
#ifndef RMESHPOLYHEDRALDOMAIN_H
#define	RMESHPOLYHEDRALDOMAIN_H

#include <CGAL/AABB_intersections.h>
#include <CGAL/Exact_predicates_inexact_constructions_kernel.h>
#include <CGAL/Mesh_3/Robust_intersection_traits_3.h>

#include <CGAL/Mesh_triangulation_3.h>
#include <CGAL/Mesh_complex_3_in_triangulation_3.h>
#include <CGAL/Mesh_criteria_3.h>

#include <CGAL/Polyhedral_mesh_domain_3.h>
#include <CGAL/make_mesh_3.h>
#include <CGAL/refine_mesh_3.h>

// IO
#include <CGAL/IO/Polyhedron_iostream.h>

class RMeshPolyhedralDomain {
public:
    // Domain
    // (we use exact intersection computation with Robust_intersection_traits_3)
    struct K: public CGAL::Exact_predicates_inexact_constructions_kernel {};
    typedef CGAL::Mesh_3::Robust_intersection_traits_3<K> Geom_traits;
    typedef CGAL::Polyhedron_3<Geom_traits> Polyhedron;
    typedef CGAL::Polyhedral_mesh_domain_3<Polyhedron, Geom_traits> Mesh_domain;

    // Triangulation
    typedef CGAL::Mesh_triangulation_3<Mesh_domain>::type Tr;
    typedef CGAL::Mesh_complex_3_in_triangulation_3<Tr> C3t3;

    // Mesh Criteria
    typedef CGAL::Mesh_criteria_3<Tr> Mesh_criteria;
    typedef Mesh_criteria::Facet_criteria Facet_criteria;
    typedef Mesh_criteria::Cell_criteria Cell_criteria;
    
public:
    RMeshPolyhedralDomain();
    void CreateMesh();

};

#endif	/* RMESHPOLYHEDRALDOMAIN_H */
