
#include <QtGui>

#include "rmainwindow.h"

RMainWindow::RMainWindow()
{

    mCentralWidget = new QWidget;
    setCentralWidget(mCentralWidget);


    mGlWidgetArea = new QScrollArea;
   // mGlWidgetArea->setWidget(mGlWidget);
    mGlWidgetArea->setWidgetResizable(true);
    mGlWidgetArea->setHorizontalScrollBarPolicy(Qt::ScrollBarAlwaysOff);
    mGlWidgetArea->setVerticalScrollBarPolicy(Qt::ScrollBarAlwaysOff);
    mGlWidgetArea->setSizePolicy(QSizePolicy::Ignored, QSizePolicy::Ignored);
    mGlWidgetArea->setMinimumSize(50, 50);

    createActions();
    createMenus();

    QGridLayout *centralLayout = new QGridLayout;
	// add other widget to the layout here, if any ...
    mCentralWidget->setLayout(centralLayout);

    setWindowTitle(tr("3D Tunnel Meshing"));
    resize(800, 600);


}

void RMainWindow::createActions()
{
	mOpenFileAct = new QAction(tr("&Open..."), this);
	mOpenFileAct->setShortcut(tr("Ctrl+O"));
	connect( mOpenFileAct, SIGNAL( triggered() ), this, SLOT( openFile() ) );

	mCreateModelAct = new QAction(tr("&Create Model"), this);
	mCreateModelAct->setShortcut(tr("Ctrl+C"));
	connect( mCreateModelAct, SIGNAL( triggered() ), this, SLOT( createModel() ) );

	mDrawModelAct = new QAction(tr("Draw &Model"), this);
	mDrawModelAct->setShortcut(tr("Ctrl+M"));
	connect( mDrawModelAct, SIGNAL( triggered() ), this, SLOT( drawModel() ) );

	mDrawAbsModelAct = new QAction(tr("Draw A&bstract Model"), this);
	mDrawAbsModelAct->setShortcut(tr("Ctrl+B"));
	connect( mDrawAbsModelAct, SIGNAL( triggered() ), this, SLOT( drawAbsModel() ) );

	mFindIntersectionsAct = new QAction(tr("&Find Intersections"), this);
	mFindIntersectionsAct->setShortcut(tr("Ctrl+F"));
	connect( mFindIntersectionsAct, SIGNAL( triggered() ), this, SLOT( findIntersections() ) );

	mDrawIntersectionsAct = new QAction(tr("Draw &Intersections"), this);
	mDrawIntersectionsAct->setShortcut(tr("Ctrl+I"));
	connect( mDrawIntersectionsAct, SIGNAL( triggered() ), this, SLOT( drawIntersections() ) );

	//DrawAll
	mDrawAllAct = new QAction(tr("Draw &All"), this);
	mDrawAllAct->setShortcut(tr("Ctrl+A"));
	connect( mDrawAllAct, SIGNAL( triggered() ), this, SLOT( drawAll() ) );


	mExitAct = new QAction(tr("E&xit"), this);
    mExitAct->setShortcut(tr("Ctrl+Q"));
    connect( mExitAct, SIGNAL( triggered() ), this, SLOT( close() ) );
}

void RMainWindow::createMenus()
{
    mFileMenu = menuBar()->addMenu(tr("&File"));

	mFileMenu->addAction(mOpenFileAct);
	mFileMenu->addAction(mCreateModelAct);
	mFileMenu->addAction(mFindIntersectionsAct);
	mFileMenu->addAction(mDrawAbsModelAct);
	mFileMenu->addAction(mDrawModelAct);
	mFileMenu->addAction(mDrawIntersectionsAct);
	mFileMenu->addAction(mDrawAllAct);
    mFileMenu->addAction(mExitAct);
}

// open the data file and load abstract model
void RMainWindow::openFile()
{
    QString filePath = QFileDialog::getOpenFileName( this, tr("Open File"), 
		mAbsModelFilePath, tr("XML files (*.xml);;TXT files (*.txt);;"));

	if (!filePath.isEmpty()){

	}
}

// draw abstract model
void RMainWindow::drawAbsModel()
{

}

// create a model from abstract model
void RMainWindow::createModel()
{

}

// draw the model
void RMainWindow::drawModel()
{

}

void RMainWindow::findIntersections()
{

}

void RMainWindow::drawIntersections()
{

}

void RMainWindow::drawAll()
{

}


