
#ifndef RMAINWINDOW_H
#define RMAINWINDOW_H

#include <QtGui>
#include <QMainWindow>

class QAction;
class QLabel;
class QMenu;
class QScrollArea;
class QSlider;
class GLWidget;

class RMainWindow : public QMainWindow
{
    Q_OBJECT

public:
    RMainWindow();

public slots:
    void openFile();
	void createModel();
	void drawModel();
	void drawAbsModel();
	void drawAll();
	void findIntersections();
	void drawIntersections();

private:
    void createActions();
    void createMenus();


	QWidget *mCentralWidget;
	QScrollArea *mGlWidgetArea;
	QMenu *mFileMenu;

	QAction *mOpenFileAct;
	QAction *mCreateModelAct;
	QAction *mDrawModelAct;
	QAction *mDrawAbsModelAct;
	QAction *mFindIntersectionsAct;
	QAction *mDrawIntersectionsAct;
	QAction *mDrawAllAct;
	QAction *mExitAct;

	QString mAbsModelFilePath;
};


#endif // RMAINWINDOW_H
