
#include "rmodel.h"

RModel::~RModel()
{
	// empty for now
}


void RModel::create()
{

        this->findUnionOfTunnels();
        this->createMesh();
}


bool RModel::createMesh()
{
    RMeshPolyhedralDomain *mesher = new RMeshPolyhedralDomain();
    mesher->CreateMesh();
    return true;
}


bool RModel::findUnionOfTunnels()
{
    // 1. Read .off files into Polyhedra
    QVector<Polyhedron> polyhedra;

        QString name = "abc.off";
        Polyhedron polyhedron;
        std::ifstream inputOFF;
        inputOFF.open(name.toLatin1(), std::ios::in);
        inputOFF >> polyhedron;
        inputOFF.close();
        polyhedra.push_back(polyhedron);

    // 2. Convert Polyhedra to Nef-polyhedra
    QVector<Nef_polyhedron> nefPolyhedra;
    for( int i = 0; i < polyhedra.size(); i++)
    {
        Polyhedron poly(polyhedra.at(i));

        if(!poly.is_closed()) return false;

        Nef_polyhedron nefPolyhedron(poly);
        nefPolyhedra.push_back(nefPolyhedron);
    }

    // 3. Find union of all Nef-polyhedra
    if (nefPolyhedra.size() == 0) return false;

    Nef_polyhedron unionNefPoly(nefPolyhedra.at(0));
    for( int i = 1; i < nefPolyhedra.size(); i++)
    {
        Nef_polyhedron nefPoly(nefPolyhedra.at(i));
        unionNefPoly += nefPoly;
    }

    // 4. Convert the resulting Nef-polyhedra to Polyhedra
    Polyhedron unionPoly;
    unionNefPoly.convert_to_polyhedron(unionPoly);

    std::ofstream outOFF;
    outOFF.open("_unionPoly.off", std::ios::trunc);
    outOFF << unionPoly;
    outOFF.close();

    return true;
}

