
#ifndef RMODEL_H
#define RMODEL_H

#include "RMeshPolyhedralDomain.h"

#include <CGAL/Exact_predicates_exact_constructions_kernel.h>
#include <CGAL/Polyhedron_3.h>
#include <CGAL/IO/Polyhedron_iostream.h>
#include <CGAL/Nef_polyhedron_3.h>
#include <CGAL/IO/Nef_polyhedron_iostream_3.h>

#include <math.h>
#include <fstream>
#include <iostream>

#include <QVector>
#include <QString>

class RModel
{
public:
    typedef CGAL::Exact_predicates_exact_constructions_kernel Kernel;
    typedef CGAL::Polyhedron_3<Kernel>  Polyhedron;
    typedef CGAL::Nef_polyhedron_3<Kernel>  Nef_polyhedron;

private:
	int mCurVertexID;
	int mCurPatchID;

public:
	~RModel();
	void create(void);

private:
    bool findUnionOfTunnels();
    bool createMesh();

};

#endif // RMODEL_H
